﻿using System;
using System.Collections.Generic;
using System.Text;

using System.Runtime.InteropServices;

namespace Bluetooth.Widcomm
{
	public class DeviceInfo
	{
		private string	m_strName		= "";
		private long	m_nAddress		= 0;
		private int		m_nClass		= 0;
		private bool	m_bConnected	= false;

		public DeviceInfo()
		{
		}

		public DeviceInfo(IntPtr pDevInfo)
		{
			BLUETOOTH_DEVICE_INFO btdi;

			btdi = (BLUETOOTH_DEVICE_INFO)Marshal.PtrToStructure(pDevInfo, typeof(BLUETOOTH_DEVICE_INFO));

			m_strName		= btdi.szName;
			m_nAddress		= btdi.Address;
			m_nClass		= btdi.ulClassOfDevice;
			m_bConnected	= btdi.fConnected != 0;
		}

		public string Name
		{
			get { return m_strName; }
		}

		public int Class
		{
			get { return m_nClass; }
		}

		public byte[] AddressAsBytes
		{
			get
			{
				byte[] addr = new byte[6];

				addr[0] = (byte)(m_nAddress         & (long)0xff);
				addr[1] = (byte)((m_nAddress >>  8) & (long)0xff);
				addr[2] = (byte)((m_nAddress >> 16) & (long)0xff);
				addr[3] = (byte)((m_nAddress >> 24) & (long)0xff);
				addr[4] = (byte)((m_nAddress >> 32) & (long)0xff);
				addr[5] = (byte)((m_nAddress >> 40) & (long)0xff);

				return addr;
			}
		}
	}
}
