﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

using Microsoft.WindowsCE.Forms;

namespace Bluetooth.Widcomm
{
	public class StackNotifySink : Microsoft.WindowsCE.Forms.MessageWindow
	{
		public const int WM_NOTIFY_INQUIRY = 0x400 + 0x100;

		private WidcommStack m_stack = null;
		private InquiryEvent m_event = null;

		public StackNotifySink()
		{
		}

		public WidcommStack Stack
		{
			get { return m_stack; }
			set { m_stack = value; }
		}

		public event InquiryEvent InquiryStateChanged
		{
			add { m_event += value; }
			remove { m_event -= value; }
		}

		private void OnInquiryStateChanged(int nState, IntPtr pDevInfo)
		{
			if(m_event != null && m_stack != null)
			{
				InquiryEventArgs e;

				if(nState == 0)
				{
					DeviceInfo devInfo = new DeviceInfo(pDevInfo);

					e = new InquiryEventArgs(devInfo);

					Marshal.FreeHGlobal(pDevInfo);
				}
				else
					e = new InquiryEventArgs();

				m_event(m_stack, e);
			}
		}

		protected override void WndProc(ref Microsoft.WindowsCE.Forms.Message msg)
		{
			if(msg.Msg == WM_NOTIFY_INQUIRY)
			{
				int		wParam = msg.WParam.ToInt32();
				IntPtr	lParam = (IntPtr)msg.LParam.ToInt32();

				OnInquiryStateChanged(wParam, lParam);
			}

			base.WndProc(ref msg);
		}
	}
}
