﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Bluetooth.Widcomm
{
	internal class WidcommAPI
	{
		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int WidcommStackPresent();

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern IntPtr CreateStack();

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern void DeleteStack(IntPtr pStack);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern void StackNotifyWindow(IntPtr pStack, IntPtr hWnd, int nMsg);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int StackStartInquiry(IntPtr pStack);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern void StackStopInquiry(IntPtr pStack);
	}

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
	public struct SYSTEMTIME
	{
		public short wYear;
		public short wMonth; 
		public short wDayOfWeek; 
		public short wDay; 
		public short wHour; 
		public short wMinute; 
		public short wSecond; 
		public short wMilliseconds;
	};

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
	public struct BLUETOOTH_DEVICE_INFO
	{
		public int dwSize;
		public long Address;
		public int ulClassOfDevice;
		public int fConnected;
		public int fRemembered;
		public int fAuthenticated;
		public SYSTEMTIME stLastSeen; 
		public SYSTEMTIME stLastUsed;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 248)]
		public string szName;
	};
}
