﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Primeworks.Bluetooth;

namespace Enumerate
{
	public partial class ServicesForm : Form
	{
		public ServicesForm(BluetoothDevice device)
		{
			InitializeComponent();

			ShowServices(device);
		}

		private void ShowServices(BluetoothDevice device)
		{
			int i;

			listServices.BeginUpdate();
			for(i = 0; i < device.Services.Count; ++i)
			{
				ListViewItem item = new ListViewItem();

				item.Text = device.Services[i].Name;
				item.SubItems.Add(device.Services[i].Guid.ToString());

				if(device.Services[i].RFComm != -1)
					item.SubItems.Add(device.Services[i].RFComm.ToString());

				listServices.Items.Add(item);
			}
			listServices.EndUpdate();
		}
	}
}