﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Primeworks.Bluetooth
{
	public class BluetoothDeviceList
	{
		private List<BluetoothDevice> m_list = new List<BluetoothDevice>(256);

		public void Add(BluetoothDevice device)
		{
			m_list.Add(device);
		}

		public void Clear()
		{
			m_list.Clear();
		}

		public int Count
		{
			get { return m_list.Count; }
		}

		public BluetoothDevice this[int iIndex]
		{
			get { return m_list[iIndex]; }
		}

		public int IndexOf(string strName)
		{
			int i;

			for(i = 0; i < m_list.Count; ++i)
			{
				if(m_list[i].Name == strName)
					return i;
			}
			return -1;
		}

		public int IndexOf(long nAddress)
		{
			int i;

			for(i = 0; i < m_list.Count; ++i)
			{
				if(m_list[i].Address == nAddress)
					return i;
			}
			return -1;
		}
	}
}
