﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Primeworks.Bluetooth
{
	public class BluetoothService
	{
		private string	m_strName	= "";
		private Guid	m_guid		= new Guid();
		private int		m_nRfComm	= -1;

		public BluetoothService(string strName, Guid guid, int nRfComm)
		{
			m_strName	= strName;
			m_guid		= guid;
			m_nRfComm	= nRfComm;
		}

		/// <summary>
		/// Gets the service name.
		/// </summary>
		public string Name
		{
			get { return m_strName; }
		}

		/// <summary>
		/// Gets the service GUID.
		/// </summary>
		public Guid Guid
		{
			get { return m_guid; }
		}

		/// <summary>
		/// Gets the RFCOMM channel number.
		/// </summary>
		public int RFComm
		{
			get { return m_nRfComm; }
		}

		#region Static Guid properties

		/// <summary>
		/// Gets the L2CAP protocol GUID.
		/// </summary>
		public static Guid L2CapProtocol
		{
			get
			{
				return new Guid(0x00000100, 0x0000, 0x1000, 0x80, 0x00, 0x00, 0x80, 0x5F, 0x9B, 0x34, 0xFB); 
			}
		}

		#endregion
	}
}
