﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Primeworks.Bluetooth
{
	public delegate void DeviceFoundEventHandler(object sender, DeviceDiscoveryCancelEventArgs e);

	public class DeviceDiscoveryCancelEventArgs : System.ComponentModel.CancelEventArgs
	{
		private BluetoothDevice m_device	= null;
		private bool			m_bEnd		= false;

		public DeviceDiscoveryCancelEventArgs(BluetoothDevice device, bool bEnd)
		{
			m_device = device;
			m_bEnd = bEnd;
		}

		public BluetoothDevice Device
		{
			get { return m_device; }
		}

		public bool NoMoreDevices
		{
			get { return m_bEnd; }
		}
	}
}
