﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Primeworks.Bluetooth
{
	public enum InquiryState
	{
		DeviceFound = 0,
		Stopped = 1
	};

	public class InquiryEventArgs : System.EventArgs
	{
		private BluetoothDevice m_devInfo = null;
		private InquiryState m_state = InquiryState.Stopped;

		public InquiryEventArgs()
		{
		}

		public InquiryEventArgs(BluetoothDevice devInfo)
		{
			m_state = InquiryState.DeviceFound;
			m_devInfo = devInfo;
		}

		/// <summary>
		/// Gets the <see cref="BluetoothDevice"/> object with a newly discovered device.
		/// </summary>
		public BluetoothDevice Device
		{
			get { return m_devInfo; }
		}

		/// <summary>
		/// Gets the inquiry state for the current event.
		/// </summary>
		public InquiryState State
		{
			get { return m_state; }
		}
	}
}
