﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Primeworks.Bluetooth.Microsoft
{
	public class MicrosoftSdpRecord : Primeworks.Bluetooth.SdpRecord
	{
		internal MicrosoftSdpRecord(IntPtr pSdpRec)
			: base(pSdpRec)
		{
		}

		public override string ServiceName
		{
			get
			{
				StringBuilder strName = new StringBuilder(256);

				if(MicrosoftAPI.SdpRecFindServiceName(m_pSdpRec, strName, 256) != 0)
					return strName.ToString();
				return "No name";
			}
		}

		public override Guid ServiceGuid
		{
			get
			{
				Guid guid = new Guid();

				MicrosoftAPI.SdpRecFindServiceClass(m_pSdpRec, out guid);

				return guid;
			}
		}

		public override int RFCOMMChannel
		{
			get
			{
				int nChannel = -1;

				MicrosoftAPI.SdpRecFindRFCommChannel(m_pSdpRec, ref nChannel);
				return nChannel;
			}
		}
	}
}
