﻿using System;
using System.Collections.Generic;
using System.Text;

using System.Runtime.InteropServices;

namespace Primeworks.Bluetooth.Widcomm
{
	internal class WidcommAPI
	{
		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int WidcommStackPresent();

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern IntPtr CreateStack();

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern void DeleteStack(IntPtr pStack);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern void StackNotifyWindow(IntPtr pStack, IntPtr hWnd, int nMsg);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int StackStartInquiry(IntPtr pStack);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern void StackStopInquiry(IntPtr pStack);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int StackStartDiscovery(IntPtr pStack, long btAddr, ref Guid pGuid);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode, EntryPoint = "StackStartDiscovery")]
		internal static extern int StackStartDiscoveryPtr(IntPtr pStack, long btAddr, IntPtr pGuid);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern IntPtr StackGetDiscovery(IntPtr pStack, long btAddr, IntPtr pGuid);

		//
		// Discovery API
		//

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int DiscoveryGetSdpRecCount(IntPtr pDiscovery);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern IntPtr DiscoveryGetSdpRec(IntPtr pDiscovery, int iRecord);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern void DeleteDiscovery(IntPtr pDiscovery);

		//
		// SdpRecord API
		//

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int SdpRecFindRFCommChannel(IntPtr pService, ref int nChannel);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int SdpRecFindServiceName(IntPtr pSdpRec, StringBuilder strName, int nNameLen);

		[DllImport("wcbts.dll", SetLastError = false, CharSet = CharSet.Unicode)]
		internal static extern int SdpRecFindServiceClass(IntPtr pSdpRec, out Guid pGuid);
	}
}
