﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Primeworks.Bluetooth.Widcomm
{
	public class WidcommSdpRecord : Primeworks.Bluetooth.SdpRecord
	{
		internal WidcommSdpRecord(IntPtr pSdpRec)
			: base(pSdpRec)
		{
		}

		public override string ServiceName
		{
			get
			{
				StringBuilder strName = new StringBuilder(256);

				if(WidcommAPI.SdpRecFindServiceName(m_pSdpRec, strName, 256) != 0)
					return strName.ToString();
				return "No name";
			}
		}

		public override Guid ServiceGuid
		{
			get
			{
				Guid guid = new Guid();

				WidcommAPI.SdpRecFindServiceClass(m_pSdpRec, out guid);

				return guid;
			}
		}

		public override int RFCOMMChannel
		{
			get
			{
				int nChannel = -1;

				WidcommAPI.SdpRecFindRFCommChannel(m_pSdpRec, ref nChannel);
				return nChannel;
			}
		}
	}
}
